const fs = require('fs');
const { ESLint } = require('eslint');
const generateTSConfig = (stagedFilenames) => (type) => {
  console.log(type);
  const tsconfig = JSON.parse(fs.readFileSync('tsconfig.json','utf8'));
  if (stagedFilenames.length === 0) return '';
  tsconfig.include = stagedFilenames;
  fs.writeFileSync('tsconfig.lint.json',JSON.stringify(tsconfig));
  return `${type} --noEmit --project tsconfig.lint.json`;
};
const removeIgnoredFiles = async (files) => {
  const eslint = new ESLint()
  const isIgnored = await Promise.all(
    files.map((file) => {
      return eslint.isPathIgnored(file)
    })
  )
  const filteredFiles = files.filter((_,i) => !isIgnored[i])
  return filteredFiles.join(' ')
}
module.exports = {
  '*.{vue,html,css,less,scss,sass}': 'npm run lint:style',
  '*.{js,jsx,vue,ts,tsx}': async (files) => {
    const filesToLint = await removeIgnoredFiles(files)
    return [`eslint --max-warnings=0 ${filesToLint}`]
  },
  '*.{ts,tsx,vue}': [(fileName) => generateTSConfig(fileName)('vue-tsc')],
};
